package org.greenstone.gsdl3.gs3build.doctypes;

import org.greenstone.gsdl3.gs3build.FileCrawlObserver;

import java.io.File;
import java.net.URL;

import org.greenstone.gsdl3.gs3build.util.URLTools;

public class RecogniserManager implements FileCrawlObserver
{
  RecogniserInterface list[];
  int                 used;
  int                 size;
    DocumentList docList;
  public RecogniserManager(DocumentList documentList)
  { this.list = new RecogniserInterface[10];
    this.used = 0;
    this.size = 10;
    this.docList = documentList;
  }

  /**
   *  Add a recogniser to this manager
   */
    public RecogniserInterface addRecogniser(String documentType)
    { 
	ClassLoader loader = ClassLoader.getSystemClassLoader();
	java.lang.Class thisClass = null;
	try {
	    thisClass = loader.loadClass("org.greenstone.gsdl3.gs3build.doctypes." + documentType + "Recogniser");
	    Object instance = thisClass.newInstance();
	    this.addRecogniser((RecogniserInterface) instance);
	    return (RecogniserInterface)instance;
	}
	catch (ClassNotFoundException ex) {
	    System.err.println(ex);
	    return null;
	}
	catch (InstantiationException instEx) {
	    System.err.println(instEx);
	}
	catch (IllegalAccessException accEx) {
	    System.err.println(accEx);
	}
	return null;
    }
    
  /**
   *
   */
    public void addRecogniser(RecogniserInterface recogniser)
    {  
	recogniser.setListRepository(this.docList);
	this.ensureCapacity(this.used + 1);
  
	this.list[this.used] = recogniser;
	this.used ++;
    }

  public void processFile(URL url)
  { boolean result;

    for (int r = 0; r < this.used; r ++)
    { if (list[r].parseDocument(url)) {
        break;
      }
    }
  }
 
  public void processFile(File file)
  { 
      System.err.println("processing file "+file.getPath());
      URL url = URLTools.getFileURL(file);
    
    if (url != null) 
    { this.processFile(url);
    }
  }

  private void ensureCapacity(int size)
  { while (size >= this.size)
    { RecogniserInterface newList [] = new RecogniserInterface[this.size*2];
      this.size *= 2;
      System.arraycopy(this.list, 0, newList, 0, this.size);
      this.list = newList;
    }
  }
}
